package org.artifactory.addon.artifact.lifecycle;

import com.fasterxml.jackson.databind.PropertyNamingStrategies;
import com.fasterxml.jackson.databind.annotation.JsonNaming;
import lombok.AllArgsConstructor;
import lombok.Data;

import javax.annotation.Nullable;

/**
 * @author Aviv Anidjar
 */

@Data
@AllArgsConstructor
@JsonNaming(PropertyNamingStrategies.SnakeCaseStrategy.class)
public class ArtifactLifecycleLinkModel {
    private String serviceId;
    private ArtifactStorageType storageType;

    @Nullable
    private ArtifactLifecycleColdLinkModel artifactLifecycleColdLink;

    public ArtifactLifecycleLinkModel() {
    }

    @Data
    @AllArgsConstructor
    @JsonNaming(PropertyNamingStrategies.SnakeCaseStrategy.class)
    public static class ArtifactLifecycleColdLinkModel {
        private String url;
        private String serviceId;
    }
}