package org.artifactory.descriptor.artifact.lifecycle;

import lombok.Data;
import org.artifactory.descriptor.Descriptor;
import org.jfrog.common.config.diff.DiffKey;
import org.jfrog.common.config.diff.GenerateDiffFunction;
import org.jfrog.common.config.validation.NotUnicode;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlType;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Uriah Levy
 */
@XmlType(name = "ArtifactLifecycleSettingsType", propOrder = {
        "jfrogColdStorageArchivingNamespace", "artifactLifecyclePolicies"})
@GenerateDiffFunction
@Data
public class ArtifactLifecycleSettings implements Descriptor {

    @XmlElement
    @DiffKey
    @NotUnicode
    private String jfrogColdStorageArchivingNamespace;

    @XmlElementWrapper(name = "artifactLifecyclePolicies")
    @XmlElement(name = "artifactLifecyclePolicy")
    private List<ArtifactLifecyclePolicyDescriptor> artifactLifecyclePolicies = new ArrayList<>();

    public List<ArtifactLifecyclePolicyDescriptor> getArtifactLifecyclePolicies() {
        return artifactLifecyclePolicies;
    }
}
