package org.artifactory.storage.db;

import org.artifactory.common.home.ArtifactoryHome;
import org.artifactory.storage.db.version.ArtifactoryDBVersion;
import org.artifactory.storage.db.version.converter.DBConverter;
import org.artifactory.storage.db.version.converter.DbDetails;
import org.artifactory.storage.db.version.converter.LockingDBSqlConverter;

import java.util.stream.Stream;

/**
 * Database Converter Adapter for distributed_locks table.
 * <p>Works only on DBConverters that supports distributed_locks</p>
 */
public class LockingDBConverterAdapter extends DatabaseConverterAdapter {

    public LockingDBConverterAdapter(ArtifactoryHome artifactoryHome, DbDetails dbDetails) {
        super(artifactoryHome, dbDetails);
    }

    @Override
    protected DBConverter[] getDBConverters(ArtifactoryDBVersion dbVersion) {
        return Stream.of(super.getDBConverters(dbVersion))
                .filter(dbConverter -> dbConverter instanceof LockingDBSqlConverter)
                .toArray(DBConverter[]::new);
    }
}
