package org.artifactory.storage.db.fs.model;

import org.artifactory.api.context.ContextHelper;
import org.artifactory.storage.fs.service.FileService;
import org.artifactory.storage.fs.service.NodeMetaInfoService;
import org.artifactory.storage.fs.service.PropertiesService;
import org.artifactory.storage.fs.service.StatsService;
import org.artifactory.storage.fs.service.WatchesService;
import org.springframework.stereotype.Component;

/**
 * @author Eli Skoran 02/03/2021
 */

@Component
public class DbMutableItemDeleteHelper {

    public void deleteItem(long id) {
        getStatsService().deleteStats(id);
        getWatchesService().deleteWatches(id);
        getPropertiesService().deleteProperties(id);
        getNodeMetaInfoService().deleteMetaInfo(id);
        getFileService().deleteItem(id);
    }

    private FileService getFileService() {
        return ContextHelper.get().beanForType(FileService.class);
    }

    private PropertiesService getPropertiesService() {
        return ContextHelper.get().beanForType(PropertiesService.class);
    }

    private WatchesService getWatchesService() {
        return ContextHelper.get().beanForType(WatchesService.class);
    }

    private StatsService getStatsService() {
        return ContextHelper.get().beanForType("statsServiceImpl", StatsService.class);
    }

    private NodeMetaInfoService getNodeMetaInfoService() {
        return ContextHelper.get().beanForType(NodeMetaInfoService.class);
    }
}
